<template>
  <q-dialog
    v-model="showDialog"
    persistent
    @hide="setTitle"
  >
    <q-card class="stepper-composing">
      <q-btn
        class="float-right q-ma-md"
        color="info"
        icon="close"
        round
        dense
        flat
        to="/compositions"
      />

      <q-stepper
        ref="stepper"
        v-model="step"
        header-class="q-pl-xl"
        :header-nav="Boolean(value.topicId)"
        color="primary"
        animated
        flat
      >
        <q-step
          :name="1"
          title="Tema"
          icon="fas fa-pencil-alt"
          :done="step > 1"
        >
          <q-card flat>
            <q-card-section>
              <div class="text-center text-h5 text-bold text-blue-8">
                Qual o tema da sua redação?
              </div>
            </q-card-section>

            <q-card-section class="row justify-center q-pt-xs">
              <q-select
                v-model="value.topicId"
                :options="topicOptions"
                class="col-10 q-pa-sm"
                label="Informe o tema"
                option-label="name"
                option-value="id"
                color="primary"
                options-cover
                options-dense
                bottom-slots
                map-options
                emit-value
                autofocus
                outlined
                dense
                :error="vuelidate.topicId.$error"
                @input="$refs.stepper.next()"
              >
                <template v-slot:after>
                  <q-btn
                    v-if="value.topicId"
                    padding="7px 11px"
                    color="primary"
                    label="OK"
                    @click="$refs.stepper.next()"
                  />
                </template>

                <template v-slot:error>
                  <div
                    v-for="(errorMessage, index) in errorMessages(vuelidate.topicId)"
                    :key="index"
                  >
                    {{ errorMessage }}
                  </div>
                </template>
              </q-select>
            </q-card-section>
          </q-card>
        </q-step>

        <q-step
          :name="2"
          title="Título"
          icon="fas fa-pencil-alt"
        >
          <q-card flat>
            <q-card-section>
              <div class="text-center text-h5 text-bold text-blue-8">
                Deseja utilizar título nessa redação?
              </div>

              <div class="text-center text-body2 text-grey q-pt-lg">
                No ENEM, a inclusão de um título é opcional.
              </div>
            </q-card-section>

            <q-card-actions
              class="row justify-evenly q-px-xl"
              :class="{ 'q-pb-lg': !hasTitle }"
            >
              <q-btn
                class="col-5"
                label="Melhor sem título mesmo"
                padding="5px 20px"
                color="red-4"
                no-caps
                @click="setTitle"
              />

              <q-btn
                class="col-5"
                label="Prefiro adicionar um título"
                padding="5px 20px"
                color="green-4"
                no-caps
                @click="hasTitle = !hasTitle"
              />
            </q-card-actions>

            <q-card-section
              v-if="hasTitle"
              class="row justify-center"
            >
              <q-input
                v-model="value.title"
                class="col-10 q-pa-sm q-pt-lg"
                label="Informe um título"
                autofocus
                outlined
                dense
                @keyup.enter="setTitle"
              >
                <template v-slot:after>
                  <q-btn
                    v-if="value.title"
                    padding="7px 11px"
                    color="primary"
                    label="OK"
                    @click="setTitle"
                  />
                </template>
              </q-input>
            </q-card-section>
          </q-card>
        </q-step>
      </q-stepper>
    </q-card>
  </q-dialog>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'

export default {
  name: 'DialogStepper',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      default: () => ({})
    },
    vuelidate: {
      type: Object,
      default: () => ({})
    },
    showDialog: {
      type: Boolean,
      default: () => (false)
    }
  },
  asyncData: {
    topicOptionsDefault: [],
    async topicOptions () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Topics',
          params: {
            filter: {
              fields: ['id', 'name'],
              where: { isEnable: true }
            }
          }
        }

        return this.$axios(axiosConfig)
          .then(R => R.data)
          .finally(() => this.$q.loading.hide())
      } catch (err) {
        this.axiosCatch(err)
      }

      return undefined
    }
  },
  data () {
    return {
      step: 1,
      hasTitle: false
    }
  },
  watch: {
    hasTitle (hasTitle) {
      if (!hasTitle) {
        this.value.title = ''
      }
    }
  },
  methods: {
    setTitle () {
      this.$emit('hide-dialog')
      this.value.doc = this.value.title
        ? `<p style="text-align: center;">${this.value.title}</p><p data-indent="1"></p>`
        : '<p data-indent="1"></p>'
    }
  }
}
</script>
